DECLARE SUB fadein ()
DECLARE SUB fadeout ()
DECLARE SUB grad (col1%, r1%, g1%, b1%, col2%, r2%, g2%, b2%)
DECLARE SUB grad2 (r1%, g1%, b1%, r2%, g2%, b2%, r3%, g3%, b3%, r4%, g4%, b4%)
DECLARE SUB pal (colour%, r%, g%, b%)
DECLARE SUB plasma1 ()
DECLARE SUB plasma2 ()
DECLARE SUB plasma3 ()
DECLARE SUB plasma4 ()
DECLARE SUB setpal (colour%, r%, g%, b%)

TYPE rgb
    r AS INTEGER
    g AS INTEGER
    b AS INTEGER
END TYPE

DIM SHARED colors(255) AS rgb
DIM SHARED rgbval AS STRING * 1

DIM SHARED waves(1 TO 4, 1) AS INTEGER
DIM SHARED sins1(-720 TO 720) AS INTEGER
DIM SHARED sins2(-720 TO 720) AS INTEGER
DIM SHARED sins3(-720 TO 720) AS INTEGER
DIM SHARED sins4(-720 TO 720) AS INTEGER
DIM SHARED coss1(-720 TO 720) AS INTEGER
DIM SHARED coss2(-720 TO 720) AS INTEGER
DIM SHARED coss3(-720 TO 720) AS INTEGER
DIM SHARED coss4(-720 TO 720) AS INTEGER

DEFINT A-Z

SCREEN 13
RANDOMIZE TIMER
CONST PI = 3.1415926# * 2

fadeout
plasma1
plasma2
plasma3
plasma4

SCREEN 0
WIDTH 80
COLOR 14, 1
PRINT "Plasmas" + STRING$(73, " ")
COLOR 15, 0
PRINT "by Entropy"
PRINT "http://www.uslink.net/~insty/"
PRINT "entropy@hotbot.com"

SUB fadein

FOR fadestep = 63 TO 0 STEP -1
    FOR col = col1 TO col2
        r1 = colors(col).r - fadestep * (colors(col).r - r) / 63
        g1 = colors(col).g - fadestep * (colors(col).g - g) / 63
        b1 = colors(col).b - fadestep * (colors(col).b - b) / 63
        setpal col, r1, g1, b1
    NEXT
NEXT
END SUB

SUB fadeout

FOR fadestep = 0 TO 63
    FOR col = col1 TO col2
        r1 = colors(col).r - fadestep * (colors(col).r - r) / 63
        g1 = colors(col).g - fadestep * (colors(col).g - g) / 63
        b1 = colors(col).b - fadestep * (colors(col).b - b) / 63
        pal col, r1, g1, b1
    NEXT
NEXT
END SUB

'Makes a palette gradient
SUB grad (col1, r1, g1, b1, col2, r2, g2, b2)

cols = col2 - col1 + 1
rstep# = (r2 - r1 + 1) / cols
gstep# = (g2 - g1 + 1) / cols
bstep# = (b2 - b1 + 1) / cols
r# = r1
g# = g1
b# = b1
FOR col = col1 TO col2
    r# = r# + rstep#
    g# = g# + gstep#
    b# = b# + bstep#
    IF r# > 63 THEN r# = 63
    IF r# < 0 THEN r# = 0
    IF g# > 63 THEN g# = 63
    IF g# < 0 THEN g# = 0
    IF b# > 63 THEN b# = 63
    IF b# < 0 THEN b# = 0
    pal col, CINT(r#), CINT(g#), CINT(b#)
NEXT

END SUB

SUB grad2 (r1, g1, b1, r2, g2, b2, r3, g3, b3, r4, g4, b4)

rd1 = (r3 - r1) / 16
rd2 = (r4 - r2) / 16
gd1 = (g3 - g1) / 16
gd2 = (g4 - g2) / 16
bd1 = (b3 - b1) / 16
bd2 = (b4 - b2) / 16

rg1 = r1
rg2 = r2
gg1 = g1
gg2 = g2
bg1 = b1
bg2 = b2
FOR g = 1 TO 16
        rg1 = rg1 + rd1
        rg2 = rg2 + rd2
        gg1 = gg1 + gd1
        gg2 = gg2 + gd2
        bg1 = bg1 + bd1
        bg2 = bg2 + bd2
        c1 = 16 * g - 16
        c2 = 16 * g - 1
        grad c1, rg1, gg1, bg1, c2, rg2, gg2, bg2
NEXT g

END SUB

'change palette
SUB pal (colour, r, g, b)

colors(colour).r = r
colors(colour).g = g
colors(colour).b = b

END SUB

SUB plasma1

r = INT(RND * 64)
g = INT(RND * 64)
b = INT(RND * 64)
r1 = r
g1 = g
b1 = b
FOR c = 0 TO 6
    r2 = INT(RND * 64)
    g2 = INT(RND * 64)
    b2 = INT(RND * 64)
    grad 32 * c, r, g, b, 32 * c + 31, r2, g2, b2
    r = r2
    g = g2
    b = b2
NEXT
grad 32 * 7, r, g, b, 255, r1, g1, b1

FOR w = 1 TO 3
    waves(w, 0) = INT(RND * 128)
    waves(w, 1) = 180 + INT(RND * 90)
NEXT


FOR i = 0 TO 720
    sins1(i) = waves(1, 0) * SIN(i / waves(1, 1) * PI)
    sins2(i) = waves(2, 0) * SIN(i / waves(2, 1) * PI)
    sins3(i) = waves(3, 0) * SIN(i / waves(3, 1) * PI)
    coss1(i) = waves(1, 0) * COS(i / waves(1, 1) * PI)
    coss2(i) = waves(2, 0) * COS(i / waves(2, 1) * PI)
    coss3(i) = waves(3, 0) * COS(i / waves(3, 1) * PI)
NEXT

f = 0
s1off = 0
s2off = 0
s3off = 0
c1off = 0
c2off = 0
c3off = 0
coloff = 0
DEF SEG = &HA000
FOR frame = 1 TO 1000
    IF frame < 64 THEN
        FOR col = 0 TO 255
            r1 = colors(col).r - (63 - frame) * (colors(col).r - 63) / 63
            g1 = colors(col).g - (63 - frame) * (colors(col).g - 63) / 63
            b1 = colors(col).b - (63 - frame) * (colors(col).b - 63) / 63
            setpal col, r1, g1, b1
        NEXT
    END IF
    s1off = (s1off + 1) MOD waves(1, 1)
    c1off = (c1off + 3) MOD waves(1, 1)
    s2off = (s2off + 3) MOD waves(2, 1)
    c2off = (c2off + 2) MOD waves(2, 1)
    s3off = (s3off + 2) MOD waves(3, 1)
    c3off = (c3off + 1) MOD waves(3, 1)
    coloff = (coloff + 1) MOD 256
    p& = 0
    FOR y = 0 TO 99
        cy = coloff + coss1(y + c1off) + sins2(y + s2off) + sins3(y + s3off)
        FOR x = 0 TO 159
            c = (cy + sins1(x + s1off) + coss2(x + c2off) + coss3(x + y + c3off)) 'MOD 128
            POKE p&, c
            POKE p& + 1, c
            POKE p& + 320, c
            POKE p& + 321, c
            p& = p& + 2
        NEXT x
        p& = p& + 320
    NEXT y
    IF INKEY$ <> "" THEN
        IF frame < 64 THEN frame = 1000 - frame
        IF frame < 1000 - 63 THEN frame = 1000 - 63
    END IF
    IF frame > 1000 - 63 THEN
        FOR col = 0 TO 255
            r1 = colors(col).r - (frame - 1000 + 63) * (colors(col).r - 63) / 63
            g1 = colors(col).g - (frame - 1000 + 63) * (colors(col).g - 63) / 63
            b1 = colors(col).b - (frame - 1000 + 63) * (colors(col).b - 63) / 63
            setpal col, r1, g1, b1
        NEXT
    END IF
NEXT frame

END SUB

SUB plasma2


r = INT(RND * 64)
g = INT(RND * 64)
b = INT(RND * 64)
r1 = r
g1 = g
b1 = b
FOR c = 0 TO 2
    r2 = INT(RND * 64)
    g2 = INT(RND * 64)
    b2 = INT(RND * 64)
    grad 64 * c, r, g, b, 64 * c + 63, r2, g2, b2
    r = r2
    g = g2
    b = b2
NEXT
grad 64 * 3, r, g, b, 255, r1, g1, b1


FOR w = 1 TO 3
    waves(w, 0) = INT(RND * 128)
    waves(w, 1) = 180 + INT(RND * 90)
NEXT


FOR i = 0 TO 720
    sins1(i) = waves(1, 0) * SIN(i / waves(1, 1) * PI)
    sins2(i) = waves(2, 0) * SIN(i / waves(2, 1) * PI)
    sins3(i) = waves(3, 0) * SIN(i / waves(3, 1) * PI)
    coss1(i) = waves(1, 0) * COS(i / waves(1, 1) * PI)
    coss2(i) = waves(2, 0) * COS(i / waves(2, 1) * PI)
    coss3(i) = waves(3, 0) * COS(i / waves(3, 1) * PI)
NEXT

f = 0
s1off = 0
s2off = 0
s3off = 0
c1off = 0
c2off = 0
c3off = 0
coloff = 0
DEF SEG = &HA000
FOR frame = 1 TO 1000
    IF frame < 64 THEN
        FOR col = 0 TO 255
            r1 = colors(col).r - (63 - frame) * (colors(col).r - 63) / 63
            g1 = colors(col).g - (63 - frame) * (colors(col).g - 63) / 63
            b1 = colors(col).b - (63 - frame) * (colors(col).b - 63) / 63
            setpal col, r1, g1, b1
        NEXT
    END IF
    s1off = (s1off + 1) MOD waves(1, 1)
    c1off = (c1off + 3) MOD waves(1, 1)
    s2off = (s2off + 3) MOD waves(2, 1)
    c2off = (c2off + 2) MOD waves(2, 1)
    s3off = (s3off + 2) MOD waves(3, 1)
    c3off = (c3off + 1) MOD waves(3, 1)
    coloff = (coloff + 4) MOD 256
    p& = 0
    FOR y = 0 TO 199
        cy = coloff + coss1(y + c1off) + sins2(y + s2off) + sins3(y + s3off)
        FOR x = 0 TO 319
            c = cy + sins1(x + s1off) + coss2(x + c2off) + coss3(x + y + c3off)
            POKE p&, c
            p& = p& + 1
        NEXT x
    NEXT y
    IF INKEY$ <> "" THEN
        IF frame < 64 THEN frame = 1000 - frame
        IF frame < 1000 - 63 THEN frame = 1000 - 63
    END IF
    IF frame > 1000 - 63 THEN
        FOR col = 0 TO 255
            r1 = colors(col).r - (frame - 1000 + 63) * (colors(col).r - 63) / 63
            g1 = colors(col).g - (frame - 1000 + 63) * (colors(col).g - 63) / 63
            b1 = colors(col).b - (frame - 1000 + 63) * (colors(col).b - 63) / 63
            setpal col, r1, g1, b1
        NEXT
    END IF
NEXT frame

END SUB

SUB plasma3

FOR c = 0 TO 3
    r = INT(RND * 64)
    g = INT(RND * 64)
    b = INT(RND * 64)
    r2 = 0
    g2 = 0
    b2 = 0
    grad 64 * c, r2, g2, b2, 64 * c + 31, r, g, b
    grad 64 * c + 32, r, g, b, 64 * c + 63, r2, g2, b2
NEXT


FOR w = 1 TO 4
    waves(w, 0) = 64
    waves(w, 1) = 60 + INT(RND * 90)
NEXT


FOR i = -720 TO 720
    sins1(i) = waves(1, 0) * SIN(i / waves(1, 1) * PI)
    sins2(i) = waves(2, 0) * SIN(i / waves(2, 1) * PI)
    sins3(i) = waves(3, 0) * SIN(i / waves(3, 1) * PI)
    sins4(i) = waves(4, 0) * SIN(i / waves(4, 1) * PI)
    coss1(i) = waves(1, 0) * COS(i / waves(1, 1) * PI)
    coss2(i) = waves(2, 0) * COS(i / waves(2, 1) * PI)
    coss3(i) = waves(3, 0) * COS(i / waves(3, 1) * PI)
    coss4(i) = waves(4, 0) * COS(i / waves(4, 1) * PI)
NEXT

t# = TIMER
f = 0
s1off = 0
s2off = 0
s3off = 0
s4off = 0
c1off = 0
c2off = 0
c3off = 0
c4off = 0
coloff = 0
COLOR 31
DEF SEG = &HA000
FOR frame = 1 TO 1000
    IF frame < 64 THEN
        FOR col = 0 TO 255
            r1 = colors(col).r - (63 - frame) * (colors(col).r - 63) / 63
            g1 = colors(col).g - (63 - frame) * (colors(col).g - 63) / 63
            b1 = colors(col).b - (63 - frame) * (colors(col).b - 63) / 63
            setpal col, r1, g1, b1
        NEXT
    END IF
    s1off = (s1off + 1) MOD waves(1, 1)
    c1off = (c1off + 1) MOD waves(1, 1)
    s2off = (s2off - 1) MOD waves(2, 1)
    c2off = (c2off - 1) MOD waves(2, 1)
    s3off = (s3off - 1) MOD waves(3, 1)
    c3off = (c3off + 1) MOD waves(3, 1)
    s4off = (s4off + 1) MOD waves(4, 1)
    c4off = (c4off - 1) MOD waves(4, 1)
    coloff = (coloff + 1) MOD 256
    p& = 0
    FOR y = 0 TO 99
        cy1 = coloff + coss1(y + c1off)
        cy2 = coloff + coss2(y + c2off)
        cy3 = coloff + coss3(y + c3off)
        cy4 = coloff + coss4(y + c4off)
        FOR x = 0 TO 159
            c1 = (cy1 + sins1(x + s1off) + 256) MOD 64
            c2 = (cy2 + sins2(x + y + s2off) + 256) MOD 64 + 64
            c3 = (cy3 + sins3(x + s3off) + 256) MOD 64 + 128
            c4 = (cy4 + sins4(x + y + s4off) + 256) MOD 64 + 192
            POKE p&, c1
            POKE p& + 1, c2
            POKE p& + 320, c3
            POKE p& + 321, c4
            p& = p& + 2
        NEXT x
        p& = p& + 320
    NEXT y
    IF INKEY$ <> "" THEN
        IF frame < 64 THEN frame = 1000 - frame
        IF frame < 1000 - 63 THEN frame = 1000 - 63
    END IF
    IF frame > 1000 - 63 THEN
        FOR col = 0 TO 255
            r1 = colors(col).r - (frame - 1000 + 63) * (colors(col).r - 63) / 63
            g1 = colors(col).g - (frame - 1000 + 63) * (colors(col).g - 63) / 63
            b1 = colors(col).b - (frame - 1000 + 63) * (colors(col).b - 63) / 63
            setpal col, r1, g1, b1
        NEXT
    END IF
NEXT frame

END SUB

SUB plasma4

minwavelength = 100
maxwavelength = 200
maxamp = 32

r1 = 0
g1 = 0
b1 = 0
r2 = 0
g2 = 0
b2 = 63
r3 = 63
g3 = 0
b3 = 0
r4 = 0
g4 = 0
b4 = 0
grad2 r1, g1, b1, r2, g2, b2, r3, g3, b3, r4, g4, b4

FOR w = 1 TO 4
    waves(w, 0) = maxamp
    waves(w, 1) = minwavelength + INT(RND * (maxwavelength - minwavelength))
NEXT

FOR i = -720 TO 720
    sins1(i) = waves(1, 0) * SIN(i / waves(1, 1) * PI)
    sins2(i) = waves(2, 0) * SIN(i / waves(2, 1) * PI)
    sins3(i) = waves(3, 0) * SIN(i / waves(3, 1) * PI)
    sins4(i) = waves(4, 0) * SIN(i / waves(4, 1) * PI)
    coss1(i) = waves(1, 0) * COS(i / waves(1, 1) * PI)
    coss2(i) = waves(2, 0) * COS(i / waves(2, 1) * PI)
    coss3(i) = waves(3, 0) * COS(i / waves(3, 1) * PI)
    coss4(i) = waves(4, 0) * COS(i / waves(4, 1) * PI)
NEXT

s1off = 0
s2off = 0
s3off = 0
s4off = 0
c1off = 0
c2off = 0
c3off = 0
c4off = 0
coloff = 0
COLOR 31
DEF SEG = &HA000
FOR frame = 1 TO 1000
    IF frame < 64 THEN
        FOR col = 0 TO 255
            r1 = colors(col).r - (63 - frame) * (colors(col).r - 63) / 63
            g1 = colors(col).g - (63 - frame) * (colors(col).g - 63) / 63
            b1 = colors(col).b - (63 - frame) * (colors(col).b - 63) / 63
            setpal col, r1, g1, b1
        NEXT
    END IF
    p& = 0
    FOR y = 0 TO 199
        cy1 = coloff + sins1(y + s1off) + sins4(y + s4off)
        cy2 = coloff + sins2(y + s2off) + sins3(y + s3off)
        FOR x = 0 TO 319
            c1 = ABS(cy1 + coss1(x + c1off) + coss4(x + c4off)) MOD 32
            c2 = ABS(cy2 + coss2(x + c2off) + coss3(x + c3off)) MOD 32
            IF c1 > 15 THEN c1 = 31 - c1
            IF c2 > 15 THEN c2 = 31 - c2
            col = c1 XOR (c2 * 16)
            POKE p&, col
            p& = p& + 1
        NEXT x
    NEXT y
    s1off = (s1off + 1) MOD waves(1, 1)
    c1off = (c1off + 1) MOD waves(1, 1)
    s2off = (s2off - 1) MOD waves(2, 1)
    c2off = (c2off + 1) MOD waves(2, 1)
    s3off = (s3off + 1) MOD waves(3, 1)
    c3off = (c3off - 1) MOD waves(3, 1)
    s4off = (s4off - 1) MOD waves(4, 1)
    c4off = (c4off - 1) MOD waves(4, 1)
    coloff = (coloff + 1) MOD 256
    IF INKEY$ <> "" THEN
        IF frame < 64 THEN frame = 1000 - frame
        IF frame < 1000 - 63 THEN frame = 1000 - 63
    END IF
    IF frame > 1000 - 63 THEN
        FOR col = 0 TO 255
            r1 = colors(col).r - (frame - 1000 + 63) * (colors(col).r - 63) / 63
            g1 = colors(col).g - (frame - 1000 + 63) * (colors(col).g - 63) / 63
            b1 = colors(col).b - (frame - 1000 + 63) * (colors(col).b - 63) / 63
            setpal col, r1, g1, b1
        NEXT
    END IF
NEXT frame


END SUB

SUB setpal (colour, r, g, b)

OUT &H3C8, colour
OUT &H3C9, r
OUT &H3C9, g
OUT &H3C9, b

END SUB

